﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
//using System.Windows.Forms;

namespace PaChong
{
    public partial class Form1 : System.Windows.Forms.Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void BtnStart_Click(object sender, EventArgs e)
        {
            string url = "";
            Console.Clear();
            switch (cmbType.SelectedIndex)
            {
                case 0:
                    url = "https://www.oschina.net/tweets?nocache=" + new DateTime();
                    Oschina(url);
                    break;
                case 1:
                    url = "https://www.ithome.com/";
                    Ithome(url);
                    break;
                case 2:
                    url = "https://www.cnblogs.com/";
                    Cnblog(url);
                    break;
                default:
                    break;
            }
            if (string.IsNullOrEmpty(url))
            {
                System.Windows.Forms.MessageBox.Show("请选择获取的网站！");
                return;
            }
        }
        private void Cnblog(string url)
        {
            HtmlWeb web = new HtmlWeb();
            HtmlDocument doc = web.Load(url);
            HtmlNode node = doc.GetElementbyId("post_list");
            foreach (var item in node.ChildNodes)
            {
                if (item.Attributes["class"] == null || item.Attributes["class"].Value != "post_item")
                    continue;
                HtmlNode newnode = HtmlNode.CreateNode(item.OuterHtml);
                Console.WriteLine($"推荐：{newnode.SelectSingleNode("//*[@class=\"diggnum\"]").InnerText}");
                Console.WriteLine($"标题：{newnode.SelectSingleNode("//*[@class=\"titlelnk\"]").InnerText}");
                Console.WriteLine($"介绍：{newnode.SelectSingleNode("//*[@class=\"post_item_summary\"]").InnerText}");
                Console.WriteLine($"信息：{newnode.SelectSingleNode("//*[@class=\"post_item_foot\"]").InnerText}");
            }
        }
        private void Oschina(string url)
        {
            HtmlWeb web = new HtmlWeb();
            HtmlDocument doc = web.Load(url);
            HtmlNode node = doc.GetElementbyId("v-tweetlist");
            foreach (var item in node.ChildNodes)
            {
                if (!item.Name.Contains("div"))
                    continue;
                HtmlNode newnode = HtmlNode.CreateNode(item.OuterHtml);
                Console.WriteLine($"用户：{newnode.SelectSingleNode("//*[@class=\"ti-uname\"]").InnerText.Trim()}");
                Console.WriteLine($"时间：{newnode.SelectSingleNode("//*[@class=\"publish-time\"]").InnerText.Trim()}");
                var mob = newnode.SelectSingleNode("//*[@class=\"from-mob\"]");
                if (mob != null)
                    Console.WriteLine($"系统：{mob.InnerText.Trim()}");
                Console.WriteLine($"内容：{newnode.SelectSingleNode("//*[@class=\"inner-content wrap\"]").InnerText.Trim()}");
                Console.WriteLine($"点赞数：{newnode.SelectNodes("//*[@class=\"box vertical tiicon\"]")[0].InnerText.Trim()}");
                Console.WriteLine($"转发数：{newnode.SelectNodes("//*[@class=\"reply-count\"]")[0].InnerText.Trim()}");
                Console.WriteLine($"评论数：{newnode.SelectNodes("//*[@class=\"reply-count\"]")[1].InnerText.Trim()}");
                Console.WriteLine();
            }
        }
        private void Ithome(string url)
        {
            HtmlWeb web = new HtmlWeb();
            HtmlDocument doc = web.Load(url);
            HtmlNode node = doc.GetElementbyId("con");
            var allnode = node.SelectSingleNode("//*[@class=\"con-block\"]");
            var contentnode = allnode.SelectSingleNode("//*[@class=\"rt\"]");
            var alltab = contentnode.SelectSingleNode("//*[@class=\"nlst\"]");
            var newlist = alltab.SelectSingleNode("//*[@class=\"lst lst-1 new-list\"]");
            var div = newlist.ChildNodes[1];
            foreach (var item in div.ChildNodes)
            {
                foreach (var li in item.ChildNodes)
                {
                    HtmlNode newnode = HtmlNode.CreateNode(li.OuterHtml);
                    Console.Write($"{newnode.SelectSingleNode("//*[@class=\"date\"]").InnerText.Trim()}：");
                    Console.WriteLine($"{newnode.SelectSingleNode("//*[@class=\"title\"]").InnerText.Trim()}");
                    Console.WriteLine($"地址：{newnode.SelectSingleNode("//*[@class=\"title\"]").ChildNodes[0].Attributes["href"].Value}");
                }
                Console.WriteLine("========================================");
            }
        }
    }
}
